
int SNTP_get_stamp(u_long *Stamp, u_long i_adr) 
// Return whole seconds part in parameter Stamp or 0 if failed
// Stamp is number of seconds since 00:00:00 1 Jan 1900
// Function returns 0 if failed, bytes read otherwise
{
    UDPSOCKET *sock;
    SNTP_FRAME *data;
	u_short i_port;
	int sts;

    data = NutHeapAlloc(60);
	sock = NutUdpCreateSocket(0);
	memset((void *)data, 0, sizeof(*data));
	data->mode_stratum = 0x0B; 
	NutUdpSendTo(sock, i_adr, 123, data, sizeof(*data)); 
	i_adr = inet_addr("0.0.0.0");
	sts = NutUdpReceiveFrom(sock,  &i_adr, &i_port, data, sizeof(*data), 5000);
//	printf("\nNTP: from %s , %d bytes rec, TS %10lu\n",inet_ntoa(i_adr), sts, ntohl(data->TX_TS_sec) );
	NutUdpDestroySocket(sock); 
	// Do at least some checks on validity
	if(sts && i_port == 123 && (data->mode_stratum & 0xC0) != 0xc0) 
	{
		*Stamp = ntohl(data->TX_TS_sec); // We have a valid response
	}
	else
	{
		*Stamp = 0;
		sts=0;	
	}
	NutHeapFree(data);
	return sts;
}

int stamp2timedate(u_long Stamp, TIMEDATE *td)
{
	const u_long secperday = 86400;
	const u_long secperhour = 3600;

// Stamp is number of seconds since 00:00:00 1 Jan 1900
//	Stamp -= (u_long)2966371200; // Takes us to 1/1 1994 UTC
//	Stamp -= (u_long)365*24*60*60*8 + (u_long)366*24*60*60; // Takes us to 1/1 2003 UTC
//	365*24*60*60  Seconds in a year
//	366*24*60*60  Seconds in a leap year
//	td->year = Stamp / (u_long)365*24*60*60; // Years after 2003
//	Stamp %= (u_long)365*24*60*60;
//	td->day = Stamp / secperday;

	Stamp %= secperday;
	td->hour = Stamp / secperhour;
	Stamp %= secperhour;
	td->min = Stamp / 60;
	Stamp %= 60;
	td->sec = Stamp;
	td->day++;

	td->year = 0;  // Fix later
	td->day = 0;
	return 0;
}

